/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * AVR Disassembler                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper function for extracting fields from encoded instructions.
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
    assert(startBit + numBits <= (sizeof(InsnType)*8) &&
           "Instruction field out of bounds!");
    InsnType fieldMask;
    if (numBits == sizeof(InsnType)*8)
      fieldMask = (InsnType)(-1LL);
    else
      fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
    return (insn & fieldMask) >> startBit;
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 14, 2,  // Inst{15-14} ...
/* 3 */       MCD::OPC_FilterValue, 0, 249, 0, 0, // Skip to: 257
/* 8 */       MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 11 */      MCD::OPC_FilterValue, 0, 152, 0, 0, // Skip to: 168
/* 16 */      MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 19 */      MCD::OPC_FilterValue, 0, 121, 0, 0, // Skip to: 145
/* 24 */      MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 27 */      MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 43
/* 32 */      MCD::OPC_CheckField, 0, 8, 0, 32, 5, 0, // Skip to: 1351
/* 39 */      MCD::OPC_Decode, 136, 2, 0, // Opcode: NOP
/* 43 */      MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 57
/* 48 */      MCD::OPC_CheckPredicate, 0, 18, 5, 0, // Skip to: 1351
/* 53 */      MCD::OPC_Decode, 131, 2, 0, // Opcode: MOVWRdRr
/* 57 */      MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 71
/* 62 */      MCD::OPC_CheckPredicate, 1, 4, 5, 0, // Skip to: 1351
/* 67 */      MCD::OPC_Decode, 133, 2, 0, // Opcode: MULSRdRr
/* 71 */      MCD::OPC_FilterValue, 3, 251, 4, 0, // Skip to: 1351
/* 76 */      MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 79 */      MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 100
/* 84 */      MCD::OPC_CheckPredicate, 1, 47, 0, 0, // Skip to: 136
/* 89 */      MCD::OPC_CheckField, 7, 1, 1, 40, 0, 0, // Skip to: 136
/* 96 */      MCD::OPC_Decode, 237, 1, 0, // Opcode: FMULS
/* 100 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 136
/* 105 */     MCD::OPC_ExtractField, 7, 1,  // Inst{7} ...
/* 108 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 122
/* 113 */     MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 136
/* 118 */     MCD::OPC_Decode, 236, 1, 0, // Opcode: FMUL
/* 122 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 136
/* 127 */     MCD::OPC_CheckPredicate, 1, 4, 0, 0, // Skip to: 136
/* 132 */     MCD::OPC_Decode, 238, 1, 0, // Opcode: FMULSU
/* 136 */     MCD::OPC_CheckPredicate, 1, 186, 4, 0, // Skip to: 1351
/* 141 */     MCD::OPC_Decode, 134, 2, 0, // Opcode: MULSURdRr
/* 145 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 154
/* 150 */     MCD::OPC_Decode, 224, 1, 1, // Opcode: CPCRdRr
/* 154 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 163
/* 159 */     MCD::OPC_Decode, 149, 2, 2, // Opcode: SBCRdRr
/* 163 */     MCD::OPC_FilterValue, 3, 159, 4, 0, // Skip to: 1351
/* 168 */     MCD::OPC_FilterValue, 1, 35, 0, 0, // Skip to: 208
/* 173 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 176 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 185
/* 181 */     MCD::OPC_Decode, 227, 1, 1, // Opcode: CPSE
/* 185 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 194
/* 190 */     MCD::OPC_Decode, 226, 1, 1, // Opcode: CPRdRr
/* 194 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 203
/* 199 */     MCD::OPC_Decode, 166, 2, 2, // Opcode: SUBRdRr
/* 203 */     MCD::OPC_FilterValue, 3, 119, 4, 0, // Skip to: 1351
/* 208 */     MCD::OPC_FilterValue, 2, 35, 0, 0, // Skip to: 248
/* 213 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 216 */     MCD::OPC_FilterValue, 0, 0, 0, 0, // Skip to: 221
/* 221 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 230
/* 226 */     MCD::OPC_Decode, 235, 1, 2, // Opcode: EORRdRr
/* 230 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 239
/* 235 */     MCD::OPC_Decode, 138, 2, 2, // Opcode: ORRdRr
/* 239 */     MCD::OPC_FilterValue, 3, 83, 4, 0, // Skip to: 1351
/* 244 */     MCD::OPC_Decode, 130, 2, 1, // Opcode: MOVRdRr
/* 248 */     MCD::OPC_FilterValue, 3, 74, 4, 0, // Skip to: 1351
/* 253 */     MCD::OPC_Decode, 225, 1, 3, // Opcode: CPIRdK
/* 257 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 293
/* 262 */     MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 265 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 274
/* 270 */     MCD::OPC_Decode, 148, 2, 4, // Opcode: SBCIRdK
/* 274 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 283
/* 279 */     MCD::OPC_Decode, 165, 2, 4, // Opcode: SUBIRdK
/* 283 */     MCD::OPC_FilterValue, 2, 0, 0, 0, // Skip to: 288
/* 288 */     MCD::OPC_FilterValue, 3, 34, 4, 0, // Skip to: 1351
/* 293 */     MCD::OPC_FilterValue, 2, 66, 3, 0, // Skip to: 1132
/* 298 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 301 */     MCD::OPC_FilterValue, 0, 205, 0, 0, // Skip to: 511
/* 306 */     MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 309 */     MCD::OPC_FilterValue, 0, 96, 0, 0, // Skip to: 410
/* 314 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 317 */     MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 345
/* 322 */     MCD::OPC_CheckPredicate, 2, 74, 0, 0, // Skip to: 401
/* 327 */     MCD::OPC_CheckField, 13, 1, 0, 67, 0, 0, // Skip to: 401
/* 334 */     MCD::OPC_CheckField, 10, 2, 0, 60, 0, 0, // Skip to: 401
/* 341 */     MCD::OPC_Decode, 249, 1, 5, // Opcode: LDRdPtr
/* 345 */     MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 373
/* 350 */     MCD::OPC_CheckPredicate, 2, 46, 0, 0, // Skip to: 401
/* 355 */     MCD::OPC_CheckField, 13, 1, 0, 39, 0, 0, // Skip to: 401
/* 362 */     MCD::OPC_CheckField, 10, 2, 0, 32, 0, 0, // Skip to: 401
/* 369 */     MCD::OPC_Decode, 251, 1, 6, // Opcode: LDRdPtrPi
/* 373 */     MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 401
/* 378 */     MCD::OPC_CheckPredicate, 2, 18, 0, 0, // Skip to: 401
/* 383 */     MCD::OPC_CheckField, 13, 1, 0, 11, 0, 0, // Skip to: 401
/* 390 */     MCD::OPC_CheckField, 10, 2, 0, 4, 0, 0, // Skip to: 401
/* 397 */     MCD::OPC_Decode, 250, 1, 6, // Opcode: LDRdPtrPd
/* 401 */     MCD::OPC_CheckPredicate, 2, 177, 3, 0, // Skip to: 1351
/* 406 */     MCD::OPC_Decode, 247, 1, 7, // Opcode: LDDRdPtrQ
/* 410 */     MCD::OPC_FilterValue, 1, 168, 3, 0, // Skip to: 1351
/* 415 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 418 */     MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 446
/* 423 */     MCD::OPC_CheckPredicate, 2, 74, 0, 0, // Skip to: 502
/* 428 */     MCD::OPC_CheckField, 13, 1, 0, 67, 0, 0, // Skip to: 502
/* 435 */     MCD::OPC_CheckField, 10, 2, 0, 60, 0, 0, // Skip to: 502
/* 442 */     MCD::OPC_Decode, 163, 2, 8, // Opcode: STPtrRr
/* 446 */     MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 474
/* 451 */     MCD::OPC_CheckPredicate, 2, 46, 0, 0, // Skip to: 502
/* 456 */     MCD::OPC_CheckField, 13, 1, 0, 39, 0, 0, // Skip to: 502
/* 463 */     MCD::OPC_CheckField, 10, 2, 0, 32, 0, 0, // Skip to: 502
/* 470 */     MCD::OPC_Decode, 162, 2, 9, // Opcode: STPtrPiRr
/* 474 */     MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 502
/* 479 */     MCD::OPC_CheckPredicate, 2, 18, 0, 0, // Skip to: 502
/* 484 */     MCD::OPC_CheckField, 13, 1, 0, 11, 0, 0, // Skip to: 502
/* 491 */     MCD::OPC_CheckField, 10, 2, 0, 4, 0, 0, // Skip to: 502
/* 498 */     MCD::OPC_Decode, 161, 2, 9, // Opcode: STPtrPdRr
/* 502 */     MCD::OPC_CheckPredicate, 2, 76, 3, 0, // Skip to: 1351
/* 507 */     MCD::OPC_Decode, 160, 2, 10, // Opcode: STDPtrQRr
/* 511 */     MCD::OPC_FilterValue, 1, 67, 3, 0, // Skip to: 1351
/* 516 */     MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 519 */     MCD::OPC_FilterValue, 0, 13, 2, 0, // Skip to: 1049
/* 524 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 527 */     MCD::OPC_FilterValue, 0, 252, 1, 0, // Skip to: 1040
/* 532 */     MCD::OPC_ExtractField, 9, 2,  // Inst{10-9} ...
/* 535 */     MCD::OPC_FilterValue, 0, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 543 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 557
/* 548 */     MCD::OPC_CheckPredicate, 3, 30, 3, 0, // Skip to: 1351
/* 553 */     MCD::OPC_Decode, 254, 1, 0, // Opcode: LPMRdZ
/* 557 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 571
/* 562 */     MCD::OPC_CheckPredicate, 3, 16, 3, 0, // Skip to: 1351
/* 567 */     MCD::OPC_Decode, 255, 1, 0, // Opcode: LPMRdZPi
/* 571 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 585
/* 576 */     MCD::OPC_CheckPredicate, 4, 2, 3, 0, // Skip to: 1351
/* 581 */     MCD::OPC_Decode, 233, 1, 0, // Opcode: ELPMRdZ
/* 585 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 599
/* 590 */     MCD::OPC_CheckPredicate, 4, 244, 2, 0, // Skip to: 1351
/* 595 */     MCD::OPC_Decode, 234, 1, 0, // Opcode: ELPMRdZPi
/* 599 */     MCD::OPC_FilterValue, 15, 235, 2, 0, // Skip to: 1351
/* 604 */     MCD::OPC_CheckPredicate, 2, 230, 2, 0, // Skip to: 1351
/* 609 */     MCD::OPC_Decode, 140, 2, 0, // Opcode: POPRd
/* 613 */     MCD::OPC_FilterValue, 1, 73, 0, 0, // Skip to: 691
/* 618 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 621 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 635
/* 626 */     MCD::OPC_CheckPredicate, 5, 208, 2, 0, // Skip to: 1351
/* 631 */     MCD::OPC_Decode, 170, 2, 11, // Opcode: XCHZRd
/* 635 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 649
/* 640 */     MCD::OPC_CheckPredicate, 5, 194, 2, 0, // Skip to: 1351
/* 645 */     MCD::OPC_Decode, 245, 1, 11, // Opcode: LASZRd
/* 649 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 663
/* 654 */     MCD::OPC_CheckPredicate, 5, 180, 2, 0, // Skip to: 1351
/* 659 */     MCD::OPC_Decode, 244, 1, 11, // Opcode: LACZRd
/* 663 */     MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 677
/* 668 */     MCD::OPC_CheckPredicate, 5, 166, 2, 0, // Skip to: 1351
/* 673 */     MCD::OPC_Decode, 246, 1, 11, // Opcode: LATZRd
/* 677 */     MCD::OPC_FilterValue, 15, 157, 2, 0, // Skip to: 1351
/* 682 */     MCD::OPC_CheckPredicate, 2, 152, 2, 0, // Skip to: 1351
/* 687 */     MCD::OPC_Decode, 141, 2, 0, // Opcode: PUSHRr
/* 691 */     MCD::OPC_FilterValue, 2, 52, 1, 0, // Skip to: 1004
/* 696 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 699 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 708
/* 704 */     MCD::OPC_Decode, 223, 1, 0, // Opcode: COMRd
/* 708 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 717
/* 713 */     MCD::OPC_Decode, 135, 2, 0, // Opcode: NEGRd
/* 717 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 726
/* 722 */     MCD::OPC_Decode, 167, 2, 0, // Opcode: SWAPRd
/* 726 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 735
/* 731 */     MCD::OPC_Decode, 241, 1, 0, // Opcode: INCRd
/* 735 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 744
/* 740 */     MCD::OPC_Decode, 204, 1, 0, // Opcode: ASRRd
/* 744 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 753
/* 749 */     MCD::OPC_Decode, 129, 2, 0, // Opcode: LSRRd
/* 753 */     MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 762
/* 758 */     MCD::OPC_Decode, 147, 2, 0, // Opcode: RORRd
/* 762 */     MCD::OPC_FilterValue, 8, 143, 0, 0, // Skip to: 910
/* 767 */     MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 770 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 779
/* 775 */     MCD::OPC_Decode, 218, 1, 12, // Opcode: BSETs
/* 779 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 788
/* 784 */     MCD::OPC_Decode, 205, 1, 12, // Opcode: BCLRs
/* 788 */     MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 814
/* 793 */     MCD::OPC_ExtractField, 4, 3,  // Inst{6-4} ...
/* 796 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 805
/* 801 */     MCD::OPC_Decode, 143, 2, 0, // Opcode: RET
/* 805 */     MCD::OPC_FilterValue, 1, 29, 2, 0, // Skip to: 1351
/* 810 */     MCD::OPC_Decode, 144, 2, 0, // Opcode: RETI
/* 814 */     MCD::OPC_FilterValue, 3, 20, 2, 0, // Skip to: 1351
/* 819 */     MCD::OPC_ExtractField, 4, 3,  // Inst{6-4} ...
/* 822 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 831
/* 827 */     MCD::OPC_Decode, 157, 2, 0, // Opcode: SLEEP
/* 831 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 845
/* 836 */     MCD::OPC_CheckPredicate, 6, 254, 1, 0, // Skip to: 1351
/* 841 */     MCD::OPC_Decode, 209, 1, 0, // Opcode: BREAK
/* 845 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 854
/* 850 */     MCD::OPC_Decode, 169, 2, 0, // Opcode: WDR
/* 854 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 868
/* 859 */     MCD::OPC_CheckPredicate, 7, 231, 1, 0, // Skip to: 1351
/* 864 */     MCD::OPC_Decode, 253, 1, 0, // Opcode: LPM
/* 868 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 882
/* 873 */     MCD::OPC_CheckPredicate, 8, 217, 1, 0, // Skip to: 1351
/* 878 */     MCD::OPC_Decode, 232, 1, 0, // Opcode: ELPM
/* 882 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 896
/* 887 */     MCD::OPC_CheckPredicate, 9, 203, 1, 0, // Skip to: 1351
/* 892 */     MCD::OPC_Decode, 158, 2, 0, // Opcode: SPM
/* 896 */     MCD::OPC_FilterValue, 7, 194, 1, 0, // Skip to: 1351
/* 901 */     MCD::OPC_CheckPredicate, 10, 189, 1, 0, // Skip to: 1351
/* 906 */     MCD::OPC_Decode, 159, 2, 0, // Opcode: SPMZPi
/* 910 */     MCD::OPC_FilterValue, 9, 59, 0, 0, // Skip to: 974
/* 915 */     MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 918 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 932
/* 923 */     MCD::OPC_CheckPredicate, 11, 167, 1, 0, // Skip to: 1351
/* 928 */     MCD::OPC_Decode, 240, 1, 0, // Opcode: IJMP
/* 932 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 946
/* 937 */     MCD::OPC_CheckPredicate, 12, 153, 1, 0, // Skip to: 1351
/* 942 */     MCD::OPC_Decode, 231, 1, 0, // Opcode: EIJMP
/* 946 */     MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 960
/* 951 */     MCD::OPC_CheckPredicate, 11, 139, 1, 0, // Skip to: 1351
/* 956 */     MCD::OPC_Decode, 239, 1, 0, // Opcode: ICALL
/* 960 */     MCD::OPC_FilterValue, 17, 130, 1, 0, // Skip to: 1351
/* 965 */     MCD::OPC_CheckPredicate, 12, 125, 1, 0, // Skip to: 1351
/* 970 */     MCD::OPC_Decode, 230, 1, 0, // Opcode: EICALL
/* 974 */     MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 983
/* 979 */     MCD::OPC_Decode, 228, 1, 0, // Opcode: DECRd
/* 983 */     MCD::OPC_FilterValue, 11, 107, 1, 0, // Skip to: 1351
/* 988 */     MCD::OPC_CheckPredicate, 13, 102, 1, 0, // Skip to: 1351
/* 993 */     MCD::OPC_CheckField, 8, 1, 0, 95, 1, 0, // Skip to: 1351
/* 1000 */    MCD::OPC_Decode, 229, 1, 13, // Opcode: DESK
/* 1004 */    MCD::OPC_FilterValue, 3, 86, 1, 0, // Skip to: 1351
/* 1009 */    MCD::OPC_ExtractField, 8, 1,  // Inst{8} ...
/* 1012 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 1026
/* 1017 */    MCD::OPC_CheckPredicate, 14, 73, 1, 0, // Skip to: 1351
/* 1022 */    MCD::OPC_Decode, 201, 1, 14, // Opcode: ADIWRdK
/* 1026 */    MCD::OPC_FilterValue, 1, 64, 1, 0, // Skip to: 1351
/* 1031 */    MCD::OPC_CheckPredicate, 14, 59, 1, 0, // Skip to: 1351
/* 1036 */    MCD::OPC_Decode, 153, 2, 14, // Opcode: SBIWRdK
/* 1040 */    MCD::OPC_FilterValue, 1, 50, 1, 0, // Skip to: 1351
/* 1045 */    MCD::OPC_Decode, 242, 1, 0, // Opcode: INRdA
/* 1049 */    MCD::OPC_FilterValue, 1, 41, 1, 0, // Skip to: 1351
/* 1054 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1057 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 1123
/* 1062 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 1065 */    MCD::OPC_FilterValue, 0, 39, 0, 0, // Skip to: 1109
/* 1070 */    MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 1073 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1082
/* 1078 */    MCD::OPC_Decode, 221, 1, 0, // Opcode: CBIAb
/* 1082 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1091
/* 1087 */    MCD::OPC_Decode, 151, 2, 15, // Opcode: SBICAb
/* 1091 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1100
/* 1096 */    MCD::OPC_Decode, 150, 2, 0, // Opcode: SBIAb
/* 1100 */    MCD::OPC_FilterValue, 3, 246, 0, 0, // Skip to: 1351
/* 1105 */    MCD::OPC_Decode, 152, 2, 15, // Opcode: SBISAb
/* 1109 */    MCD::OPC_FilterValue, 1, 237, 0, 0, // Skip to: 1351
/* 1114 */    MCD::OPC_CheckPredicate, 1, 232, 0, 0, // Skip to: 1351
/* 1119 */    MCD::OPC_Decode, 132, 2, 0, // Opcode: MULRdRr
/* 1123 */    MCD::OPC_FilterValue, 1, 223, 0, 0, // Skip to: 1351
/* 1128 */    MCD::OPC_Decode, 139, 2, 0, // Opcode: OUTARr
/* 1132 */    MCD::OPC_FilterValue, 3, 214, 0, 0, // Skip to: 1351
/* 1137 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1140 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1149
/* 1145 */    MCD::OPC_Decode, 145, 2, 0, // Opcode: RJMPk
/* 1149 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1158
/* 1154 */    MCD::OPC_Decode, 142, 2, 0, // Opcode: RCALLk
/* 1158 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1167
/* 1163 */    MCD::OPC_Decode, 248, 1, 3, // Opcode: LDIRdK
/* 1167 */    MCD::OPC_FilterValue, 3, 179, 0, 0, // Skip to: 1351
/* 1172 */    MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 1175 */    MCD::OPC_FilterValue, 0, 43, 0, 0, // Skip to: 1223
/* 1180 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1183 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1192
/* 1188 */    MCD::OPC_Decode, 212, 1, 0, // Opcode: BRLOk
/* 1192 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1201
/* 1197 */    MCD::OPC_Decode, 210, 1, 0, // Opcode: BREQk
/* 1201 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1210
/* 1206 */    MCD::OPC_Decode, 214, 1, 0, // Opcode: BRMIk
/* 1210 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1219
/* 1215 */    MCD::OPC_Decode, 213, 1, 0, // Opcode: BRLTk
/* 1219 */    MCD::OPC_Decode, 208, 1, 16, // Opcode: BRBSsk
/* 1223 */    MCD::OPC_FilterValue, 1, 43, 0, 0, // Skip to: 1271
/* 1228 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1231 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1240
/* 1236 */    MCD::OPC_Decode, 217, 1, 0, // Opcode: BRSHk
/* 1240 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1249
/* 1245 */    MCD::OPC_Decode, 215, 1, 0, // Opcode: BRNEk
/* 1249 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1258
/* 1254 */    MCD::OPC_Decode, 216, 1, 0, // Opcode: BRPLk
/* 1258 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1267
/* 1263 */    MCD::OPC_Decode, 211, 1, 0, // Opcode: BRGEk
/* 1267 */    MCD::OPC_Decode, 207, 1, 16, // Opcode: BRBCsk
/* 1271 */    MCD::OPC_FilterValue, 2, 35, 0, 0, // Skip to: 1311
/* 1276 */    MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 1279 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1295
/* 1284 */    MCD::OPC_CheckField, 3, 1, 0, 60, 0, 0, // Skip to: 1351
/* 1291 */    MCD::OPC_Decode, 206, 1, 17, // Opcode: BLD
/* 1295 */    MCD::OPC_FilterValue, 1, 51, 0, 0, // Skip to: 1351
/* 1300 */    MCD::OPC_CheckField, 3, 1, 0, 44, 0, 0, // Skip to: 1351
/* 1307 */    MCD::OPC_Decode, 219, 1, 17, // Opcode: BST
/* 1311 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 1351
/* 1316 */    MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 1319 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1335
/* 1324 */    MCD::OPC_CheckField, 3, 1, 0, 20, 0, 0, // Skip to: 1351
/* 1331 */    MCD::OPC_Decode, 154, 2, 15, // Opcode: SBRCRrB
/* 1335 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1351
/* 1340 */    MCD::OPC_CheckField, 3, 1, 0, 4, 0, 0, // Skip to: 1351
/* 1347 */    MCD::OPC_Decode, 156, 2, 15, // Opcode: SBRSRrB
/* 1351 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 17, 3,  // Inst{19-17} ...
/* 3 */       MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 53
/* 8 */       MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 11 */      MCD::OPC_FilterValue, 72, 16, 0, 0, // Skip to: 32
/* 16 */      MCD::OPC_CheckPredicate, 2, 74, 0, 0, // Skip to: 95
/* 21 */      MCD::OPC_CheckField, 16, 1, 0, 67, 0, 0, // Skip to: 95
/* 28 */      MCD::OPC_Decode, 252, 1, 18, // Opcode: LDSRdK
/* 32 */      MCD::OPC_FilterValue, 73, 58, 0, 0, // Skip to: 95
/* 37 */      MCD::OPC_CheckPredicate, 2, 53, 0, 0, // Skip to: 95
/* 42 */      MCD::OPC_CheckField, 16, 1, 0, 46, 0, 0, // Skip to: 95
/* 49 */      MCD::OPC_Decode, 164, 2, 19, // Opcode: STSKRr
/* 53 */      MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 74
/* 58 */      MCD::OPC_CheckPredicate, 15, 32, 0, 0, // Skip to: 95
/* 63 */      MCD::OPC_CheckField, 25, 7, 74, 25, 0, 0, // Skip to: 95
/* 70 */      MCD::OPC_Decode, 243, 1, 20, // Opcode: JMPk
/* 74 */      MCD::OPC_FilterValue, 7, 16, 0, 0, // Skip to: 95
/* 79 */      MCD::OPC_CheckPredicate, 15, 11, 0, 0, // Skip to: 95
/* 84 */      MCD::OPC_CheckField, 25, 7, 74, 4, 0, 0, // Skip to: 95
/* 91 */      MCD::OPC_Decode, 220, 1, 20, // Opcode: CALLk
/* 95 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[AVR::FeatureMOVW]);
  case 1:
    return (Bits[AVR::FeatureMultiplication]);
  case 2:
    return (Bits[AVR::FeatureSRAM]);
  case 3:
    return (Bits[AVR::FeatureLPMX]);
  case 4:
    return (Bits[AVR::FeatureELPMX]);
  case 5:
    return (Bits[AVR::FeatureRMW]);
  case 6:
    return (Bits[AVR::FeatureBREAK]);
  case 7:
    return (Bits[AVR::FeatureLPM]);
  case 8:
    return (Bits[AVR::FeatureELPM]);
  case 9:
    return (Bits[AVR::FeatureSPM]);
  case 10:
    return (Bits[AVR::FeatureSPMX]);
  case 11:
    return (Bits[AVR::FeatureIJMPCALL]);
  case 12:
    return (Bits[AVR::FeatureEIJMPCALL]);
  case 13:
    return (Bits[AVR::FeatureDES]);
  case 14:
    return (Bits[AVR::FeatureADDSUBIW]);
  case 15:
    return (Bits[AVR::FeatureJMPCALL]);
  }
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 4) << 0;
    tmp |= fieldFromInstruction(insn, 9, 1) << 4;
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 4) << 0;
    tmp |= fieldFromInstruction(insn, 9, 1) << 4;
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 4, 4);
    if (DecodeLD8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 4) << 0;
    tmp |= fieldFromInstruction(insn, 8, 4) << 4;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 4, 4);
    if (DecodeLD8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 4);
    if (DecodeLD8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 4) << 0;
    tmp |= fieldFromInstruction(insn, 8, 4) << 4;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 2);
    if (DecodePTRREGSRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 3) << 0;
    tmp |= fieldFromInstruction(insn, 3, 1) << 6;
    tmp |= fieldFromInstruction(insn, 10, 2) << 3;
    tmp |= fieldFromInstruction(insn, 13, 1) << 5;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 2, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 2, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 2, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 3) << 0;
    tmp |= fieldFromInstruction(insn, 3, 1) << 6;
    tmp |= fieldFromInstruction(insn, 10, 2) << 3;
    tmp |= fieldFromInstruction(insn, 13, 1) << 5;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 4, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 4, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 14:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 4) << 0;
    tmp |= fieldFromInstruction(insn, 6, 2) << 4;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 3, 7);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 17) << 0;
    tmp |= fieldFromInstruction(insn, 20, 5) << 17;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint32_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      uint32_t ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // End llvm namespace
